# _________________________________________________________

from transformers import Trainer


class ContinualTrainer(Trainer):
    def __init__(
        self, model, args, data_collator, train_dataset, eval_dataset, accelerator
    ):
        self.accelerator = accelerator
        super().__init__(model, args, data_collator, train_dataset, eval_dataset)

    def create_accelerator_and_postprocess(self):
        if self.accelerator is not None:
            self.is_deepspeed_enabled = (
                getattr(self.accelerator.state, "deepspeed_plugin", None)
                is not None
            )
            self.is_fsdp_enabled = (
                getattr(self.accelerator.state, "fsdp_plugin", None) is not None
            )
            self.gather_function = self.accelerator.gather_for_metrics
            return
        else:
            super().create_accelerator_and_postprocess()